<?
###########################################################################
#
# class.common.php -  NagTrap class with functions to connect to the
#					  MySQL-Database
#
# Copyright (c) 2006 - 2007 Michael Luebben (nagtrap@nagtrap.org)
# Last Modified: 13.10.2007
#
# License:
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

/**
* This Class handles database-connection and - queries
*/
class database {
  
   
  
   /**
	* Constructor
	*
	* @param config $configINI
	*
	* @author Michael Luebben <nagtrap@nagtrap.org>
	*/  
    function database(&$configINI) {
		$this->configINI = &$configINI;
	}
	
	/**
	* Make a connection to the database
	*
	* @param array $configINI
	*
	* @author Michael Luebben <nagtrap@nagtrap.org>
	*/  
	function connect() {
       global $configINI, $FRONTEND;
       $connect = @mysql_connect($configINI['database']['host'], $configINI['database']['user'], $configINI['database']['password']);
       $dbSelect['code'] = @mysql_select_db($configINI['database']['name'], $connect);
       // On error, create a array entry with the mysql error
       if(!$dbSelect['code']) {
          $FRONTEND->printError("DBCONNECTION",mysql_error());
		  $FRONTEND->closeSite();
          $FRONTEND->printSite();
          exit;
       }
       return($dbSelect);
    }
    
    /**
	* Read Traps from database
	*
	* @param string $sort
	* @param boolean $limit
	* @param string $hostname
	* @param array $table
	*
	* @author Michael Luebben <nagtrap@nagtrap.org>
	*/  
	function readTraps($limit) {
  	global $hostname, $table, $FRONTEND;
    $traps = array();
    $dbQuerySet = array();
    // Create WHERE clausel
    if($_REQUEST['severity'] == "" and $_REQUEST['hostname'] == "" and $_REQUEST['category'] == "" or $_REQUEST['severity'] == "UNKNOWN") {
    	$dbQuery = "";
		}
		if ($_REQUEST['severity'] != "") {
			    	print "2 ";
	  	$dbQuerySet[] = "severity = '".$_REQUEST['severity']."'"; 
		}
    if ($_REQUEST['hostname'] != "") {
			$parse = explode(":",$_REQUEST['hostname']);
			$first = true;
			$query="";
			foreach ($parse as $p ) {
      	if ($first) {
	   			$query = "(hostname like '$p%' ";
        	$first = false;
				} else {
					$query .= " or hostname like '$p%' ";
				}
			}
			$query.=") ";
       //$dbQuerySet[] = "hostname = '".$_REQUEST['hostname']."'"; 
      $dbQuerySet[] = $query;
    }
		if ($_REQUEST['category'] != "") {
			$dbQuerySet[] = "category = '".rawurldecode($_REQUEST['category'])."'"; 
		}

	   // Set which trap musst reed first from database
	  if ($_REQUEST['oldestfirst'] == "on") {
			$sort = "ASC";
		} else {
			$sort = "DESC";
		} 
		// Read traps from database
		if ($_REQUEST['parsestr'] != "") {
			//$query = "SELECT * FROM ".$table['name']." ".$dbQuery." and formatline like '%{$_REQUEST['system']}%' and ( ";
			$parse = array();
			$parse = explode(":",$_REQUEST['parsestr']);
			$first = true;
			$query="";
			foreach ($parse as $p ) {
				if ($first) {
					$query = "(formatline like '%$p%' ";
			  	$first = false;
				} else {
					$query .= " or formatline like '%$p%' ";
				}
			}
			$query.=") ";
			$dbQuerySet[] = $query;
		}
		if ($_REQUEST['ignorestr'] != "") {
			//$query = "SELECT * FROM ".$table['name']." ".$dbQuery." and formatline like '%{$_REQUEST['system']}%' and ( ";
			$parse = array();
			$parse = explode(":",$_REQUEST['ignorestr']);
			$first = true;
			$query="";
			foreach ($parse as $p ) {
				if ($first) {
					$query = "( formatline not like '%$p%' ";
					$first = false;
				} else {
					$query .= " and formatline not like '%$p%' ";
				}
			}
			$query.=") ";
			$dbQuerySet[] = $query;
		
		}
		if ($_REQUEST['system'] != "") {
			$dbQuerySet[] = " formatline like '%{$_REQUEST['system']}%' ";
		}
		if (count($dbQuerySet)>0) {
			$dbQuery = "WHERE ".implode($dbQuerySet," AND ");
		}
		$query = "SELECT * FROM ".$table['name']." ".$dbQuery." ";
		$query .= " ORDER BY id ".$sort." LIMIT ".$limit;

    //print $query;
    //exit(0);
    
		$result = @mysql_query($query);
    // On error, create a array entry with the mysql error
    if(!$result) {
    	$FRONTEND->printError("DBTABLE",mysql_error());
		  $FRONTEND->closeSite();
			$FRONTEND->printSite(); 
			exit; 
		}
   
		while ($line = @mysql_fetch_array($result)) {      
    	$traps[] = $line;
		}

		/*
		* Added by OpServices
		* This code makes the traps visible only if user has permission
		*/
		$temp = array();
		foreach ($traps as $trap) {
		  $temp[] = $trap;
		}
		return($temp);
	}
	
	/**
	* Handle a Traps in the database
	*
	* @param string $handle
	* @param boolean $trapID
	* @param string $tableName
	*
	* @author Michael Luebben <nagtrap@nagtrap.org>
	*/  
	function handleTrap($handle,$trapID,$tableName) {
	   global $FRONTEND;
	   if($handle == "mark") {
          $query = "UPDATE $tableName SET trapread = 1 WHERE id = $trapID";
          $result = mysql_query($query);
       }elseif($handle == "delete") {
          $query = "DELETE FROM $tableName WHERE id = $trapID";
          $result = mysql_query($query);
       }elseif($handle == "archive") {
          $result = mysql_query("SELECT * FROM $tableName WHERE id = $trapID");
          $trap = mysql_fetch_array($result);
		  $query = "INSERT INTO snmptt_archive (snmptt_id, eventname, eventid, trapoid, enterprise, community,
		  										hostname, agentip, category, severity, uptime, traptime,
												formatline, trapread) 
		  								VALUES ('$trap[id]', '$trap[eventname]', '$trap[eventid]', '$trap[trapoid]', 
										        '$trap[enterprise]', '$trap[community]', '$trap[hostname]',
												'$trap[agentip]', '$trap[category]', '$trap[severity]', '$trap[uptime]',
												'$trap[traptime]', '$trap[formatline]', '$trap[trapread]')";
          $result = mysql_query($query);
          $query = "DELETE FROM $tableName WHERE id = $trapID";
          $result = mysql_query($query);
       }     
       if(!$result) {
          $FRONTEND->printError("DBHANDLETRAP",mysql_error());
		  $FRONTEND->closeSite();
          $FRONTEND->printSite(); 
          exit; 
       }
       return($result);
    }
    
    /**
	* Read Trap-Infromation from the database
	*
	* @param string $tableName
	*
	* @author Michael Luebben <nagtrap@nagtrap.org>
	*/  
    function infoTrap($tableName) {
       global $FRONTEND;
       $query = "SELECT id,traptime FROM $tableName ORDER BY id";
       $result = mysql_query($query);
       if(!$result) {
          $FRONTEND->printError("DBREADTRAP",mysql_error());
		  $FRONTEND->closeSite();
          $FRONTEND->printSite(); 
          exit; 
       }
       while ($line = mysql_fetch_array($result)) {
          $trapTime[] = $line['traptime']; 
       }
       if ($trapTime[0] != "") {
   	      $trap[last] = array_pop($trapTime);
   	      $trap[first] = array_pop(array_reverse($trapTime));
       }
       return($trap);
    }

	/**
	* Read category from database
	*
	* @author Michael Luebben <nagtrap@nagtrap.org>
	*
	*/
	function readCategory($tableName) {
	   global $FRONTEND;
	   $query = "SELECT DISTINCT category FROM $tableName";
	   $result = mysql_query($query);
	   if(!$result) {
          $FRONTEND->printError("DBREADCATEGORY",mysql_error());
		  $FRONTEND->closeSite();
          $FRONTEND->printSite(); 
          exit; 
       }

	   while ($line = mysql_fetch_array($result)) {
	      $category[] = $line['category'];
	   }
	   return($category);
	} 

}
